<?php
/**
 * Main hlpfw
 *
 * @since             1.0.0
 * @package
 *
 */

 // If this file is called directly, abort.
 if ( ! defined( 'WPINC' ) ) {
 	die;
 }

/**
 *
 * Main redirect function
 *
 * @since             1.0.0
 */
function hlpfw_template_redirect()
{
 global $post;
 if ( is_product() && get_post_meta( $post->ID, '_hlpfw_hide_product', true ) == 'yes') {
   // Url variable
     $url_variable = get_post_meta( $post->ID, '_hlpfw_product_url_variable', true );
     if(isset($_GET[$url_variable]))
   {
   // If url key matches load the Product page
   } else {
     global $wp_query;
     $wp_query->set_404();
     status_header( 404 );
   //wp_redirect('');
  }
 }
}
add_action('template_redirect','hlpfw_template_redirect');

/**
*
* Only hide add to cart button if that option is selected
*
* @return WP_Query $query
* @since             1.0.1
*/
add_action( 'woocommerce_single_product_summary', 'remove_add_to_cart_button', 1 );
function remove_add_to_cart_button() {
    global $post;
    global $product;
    // Check if we need to hide add to cart button
    $hlpfw_hide_add_to_cart = get_post_meta( $post->ID, '_hlpfw_hide_add_to_cart', true );
    $hlpfw_product_url_variable = get_post_meta( $post->ID, '_hlpfw_product_url_variable', true );
    if ($hlpfw_hide_add_to_cart == 'yes' && !isset($_GET[$hlpfw_product_url_variable])) {
      // For variable product types (keeping attribute select fields)
      if( $product->is_type( 'variable' ) ) {
          remove_action( 'woocommerce_single_variation', 'woocommerce_single_variation_add_to_cart_button', 20 );
      }
      // For all other product types
      else {
          remove_action( 'woocommerce_single_product_summary', 'woocommerce_template_single_add_to_cart', 30 );
      }
    }


}

/**
*
* Replacing the button add to cart by a link to the product in Shop and archives pages
*
* @return WP_Query $query
* @since             1.0.1
*/
add_filter( 'woocommerce_loop_add_to_cart_link', 'replace_loop_add_to_cart_button', 10, 2 );
function replace_loop_add_to_cart_button( $button, $product  ) {
  global $post;
  // Check if we need to hide add to cart button
  $hlpfw_hide_add_to_cart = get_post_meta( $post->ID, '_hlpfw_hide_add_to_cart', true );
  $hlpfw_product_url_variable = get_post_meta( $post->ID, '_hlpfw_product_url_variable', true );
  if ($hlpfw_hide_add_to_cart == 'yes') {
    $newHref = $product->get_permalink();
    $pattern = "/(?<=href=(\"|'))[^\"']+(?=(\"|'))/";
    $button = preg_replace($pattern, $newHref, $button);
  }
    return $button;
}


/**
*
* Filter hidden products from "pre_get_posts"
* Don't display hidden products in the catalog / archive
*
* @return WP_Query $query
* @since             1.0.0
*/
function hlpfw_pre_get_posts( $query ) {
 // Admins can see all products
 if ( is_admin() ) return $query;
 // target product archives only
 if ( !$query->is_post_type_archive('product') ) return $query;
 // Meta query
 $meta_query = array();
 if ( !empty($query->get('meta_query')) ) {
   $meta_query = array(
     'relation' => 'AND',
     $query->get('meta_query')
   );
 }
 $meta_query[] = array(
 'relation' => 'OR',
 array(
   'key' => '_hlpfw_hide_product',
   'value' => '', //<--- not required but necessary in this case
   'compare' => 'NOT EXISTS',
 ),
 array(
   'key'       => '_hlpfw_hide_product',
   'value'     => 'yes',
   'compare'   => 'NOT IN'
   ),
 );

 $query->set('meta_query', $meta_query);
 return $query;
}
add_action( 'pre_get_posts', 'hlpfw_pre_get_posts', 20 );
