<?php
/**
 * Admin Fields hlpfw
 *
 * @since             1.0.0
 * @package
 *
 */

 // If this file is called directly, abort.
 if ( ! defined( 'WPINC' ) ) {
 	die;
 }


// Add fields
add_action('woocommerce_product_options_general_product_data', 'hlpfw_woocommerce_product_options_general_product_data');
function hlpfw_woocommerce_product_options_general_product_data(){
    global $post;
    echo '<div class="hlpfw_product_custom_field">';
    // Custom Product Checkbox Field
    woocommerce_wp_checkbox( array(
        'id'        => '_hlpfw_hide_product',
        'desc'      => __('Hide this product', 'woocommerce'),
        'label'     => __('Hide this product', 'woocommerce'),
        'desc_tip'  => 'true'
    ));
    // Custom Product Text Field
    woocommerce_wp_text_input(
      array(
        'id'          => '_hlpfw_product_url_variable',
        'label'       => __( 'Hidden URL Variable', 'woocommerce' ),
        'placeholder' => 'Ex: promotion',
        'desc_tip'    => 'true'
      ));
      woocommerce_wp_checkbox( array(
          'id'        => '_hlpfw_hide_add_to_cart',
          'desc'      => __('Only Remove Add to cart button if visited without hidden URL. <b>If using this option uncheck "Hide this product"</b>', 'woocommerce'),
          'label'     => __('Only Remove Add to cart button if visited without hidden URL. <b>If using this option uncheck "Hide this product"</b>', 'woocommerce'),
          'desc_tip'  => 'true'
      ));
    $post_permalink = get_post_permalink($post->ID);
    $hlpfw_product_url_variable = get_post_meta( $post->ID, '_hlpfw_product_url_variable', true );
    echo'<div id="hlpfw_product_url_helper_h">Your Hidden URL is: <span id="hlpfw_product_url_helper">'.$post_permalink.'?'.$hlpfw_product_url_variable.'</span></div>';
    echo"
    <style>
    #hlpfw_product_url_helper_h {
     padding: 5px 12px;
    }
    </style>
    <script>
    jQuery(document).ready(function() {
      var hlpfw_product_url_variable = document.getElementById('_hlpfw_product_url_variable');
      var hlpfw_product_url_helper = jQuery('#hlpfw_product_url_helper');
      hlpfw_product_url ='".$post_permalink."';

      hlpfw_product_url_variable.onkeyup = function() {
          var hlpfw_product_url_helper_result = hlpfw_product_url + '?' + jQuery( this ).val();
          hlpfw_product_url_helper.html(hlpfw_product_url_helper_result);
      };
      // Trigger on load
      //hlpfw_product_url_variable.trigger('keyup');
    });
    </script>";
    echo '</div>';
}
// Save Fields
add_action('woocommerce_process_product_meta', 'hlpfw_woocommerce_process_product_meta');
function hlpfw_woocommerce_process_product_meta($post_id){
    // Hide this Product Checkbox
    $hlpfw_hide_product = isset( $_POST['_hlpfw_hide_product'] ) ? 'yes' : 'no';
    update_post_meta($post_id, '_hlpfw_hide_product', esc_attr( $hlpfw_hide_product ));
    // Hidden Product URL Variable Field
    $woocommerce_hlpfw_product_url_variable = $_POST['_hlpfw_product_url_variable'];
    if (!empty($woocommerce_hlpfw_product_url_variable)) {
    update_post_meta($post_id, '_hlpfw_product_url_variable', esc_attr($woocommerce_hlpfw_product_url_variable));
    // Only Remove Add to cart button
    $hlpfw_hide_add_to_cart = isset( $_POST['_hlpfw_hide_add_to_cart'] ) ? 'yes' : 'no';
    update_post_meta($post_id, '_hlpfw_hide_add_to_cart', esc_attr( $hlpfw_hide_add_to_cart ));
    }
}
